package {
    import caurina.transitions.Tweener;
    
    import fl.controls.Button;
    import fl.controls.ComboBox;
    import fl.controls.NumericStepper;
    
    import flash.display.Sprite;
    import flash.display.StageScaleMode;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.filters.BlurFilter;
    import flash.filters.GlowFilter;
    import flash.text.TextField;
    import flash.text.TextFieldAutoSize;
    import flash.text.TextFormat;
    
    [SWF(width="600", height="400", frameRate="30", backgroundColor="#000000")]
	public class DrawLine extends Sprite
	{
        private var button:Button;
        private var combo:ComboBox;
        private var stepper:NumericStepper;
        private var easingCombo:ComboBox;
        private var isPlay:Boolean;
        private var shapeDatas:Array;
        private var isIn:Boolean;
        private var thicknessType:String;
        private var thickness:uint;
        
		public function DrawLine()
		{
            stage.scaleMode = StageScaleMode.NO_SCALE;
            super();
            isPlay = false;
            thicknessType = ShapeDataSet.IN;
            thickness = 20;
            initButton();
            
            shapeDatas = new Array();
            var data:XML;
            var shapeDataSet:ShapeDataSet;
            var gf:GlowFilter = new GlowFilter(0x85FFA2, 1, 32, 32, 2, 2);
            var bf:BlurFilter = new BlurFilter(2,2,1);
            for(var i:uint = 0; i < 4; i++)
            {
                data = DataPoolXML["data" + (i + 1)];
                shapeDataSet = new ShapeDataSet(data);
                shapeDataSet.filters = [bf,gf];
                addChild(shapeDataSet);
                shapeDatas[i] = shapeDataSet;
            }
		}
		
        private function initButton():void
        {
        	var label:TextField;
        	var tf:TextFormat = new TextFormat();
        	tf.color = 0xffffff;
        	tf.font = "_等幅";
        	
            button = new Button();
            addChild(button);
            button.label = "スタート";
            button.addEventListener(MouseEvent.CLICK, playStop); 
            button.setSize(100, 50);
            button.move(stage.stageWidth - button.width -10, stage.stageHeight -button.height -10);
            
            combo = new ComboBox();
            addChild(combo);
            combo.addItem( { label: "LENEAR", data:ShapeDataSet.LENEAR } );
            combo.addItem( { label: "IN", data:ShapeDataSet.IN } );
            combo.addItem( { label: "OUT", data:ShapeDataSet.OUT } );
            combo.addItem( { label: "RIBBON", data:ShapeDataSet.RIBBON } );
            combo.addItem( { label: "UFO", data:ShapeDataSet.UFO } );
            combo.selectedIndex = 1;
            combo.addEventListener(Event.CHANGE, comboSelected);  
            combo.move(button.x, button.y - combo.height - 30);
            label = new TextField();
            label.text = "thicknessType";
            label.setTextFormat(tf);
            addChild(label);
            label.x = combo.x;
            label.y = combo.y - 20;
            label.autoSize = TextFieldAutoSize.LEFT;
            label.height = 10;
            
            stepper = new NumericStepper();
            stepper = new NumericStepper();
            stepper.stepSize = 1;
            stepper.minimum = 1;
            stepper.maximum = 100;
            stepper.value = thickness;
            stepper.move(combo.x, combo.y - stepper.height - 30);
            stepper.addEventListener(Event.CHANGE, stepperChanged);
            addChild(stepper);
            label = new TextField();
            label.text = "thickness";
            label.setTextFormat(tf);
            addChild(label);
            label.x = stepper.x;
            label.y = stepper.y - 20;
            label.autoSize = TextFieldAutoSize.LEFT;
            label.height = 10;
            
            easingCombo = new ComboBox();
            addChild(easingCombo);
            easingCombo.addItem( { label: "Sine" } );
            easingCombo.addItem( { label: "Quad" } );
            easingCombo.addItem( { label: "Cubic" } );
            easingCombo.addItem( { label: "Quart" } );
            easingCombo.addItem( { label: "Quint" } );
            easingCombo.addItem( { label: "Expo" } );
            easingCombo.move(stepper.x, stepper.y - easingCombo.height - 30);
            easingCombo.addEventListener(Event.CHANGE, easingChanged);
            
            label = new TextField();
            label.text = "easing";
            label.setTextFormat(tf);
            addChild(label);
            label.x = easingCombo.x;
            label.y = easingCombo.y - 20;
            label.autoSize = TextFieldAutoSize.LEFT;
            label.height = 10;
        }
        
        private function comboSelected(e:Event):void
        {
        	thicknessType = combo.selectedItem.data;
        }
        
        private function easingChanged(e:Event):void
        {
        	
        }
        
        private function stepperChanged(e:Event):void
        {
        	thickness = stepper.value;
        }
        
        private function playStop(e:MouseEvent):void
        {
            if(isPlay)
            {
                Tweener.removeAllTweens();
                isPlay = false;
                button.label = "スタート";
            }
            else
            {
                isPlay = true;
                button.label = "ストップ";
                isIn = true;
                drawAnime();
            }
        }
        
        private function drawAnime():void
        {
        	var i:uint;
        	var cnt:uint = shapeDatas.length;
        	var callback:Function = function():void
        	{
        		cnt--;
        		if(cnt == 0)
        		{
	                isIn = !isIn;
	                drawAnime();
        		}

        	}
        	if(isIn)
        	{
	            for(i = 0; i < shapeDatas.length; i++)
	            {
	                shapeDatas[i].beginFill(0xffffff, 1);
	                shapeDatas[i].start_t = 0;
	                shapeDatas[i].end_t = 0;
	                shapeDatas[i].setThicknessType(thicknessType, thickness);
	                Tweener.addTween(shapeDatas[i], {
	                   end_t:1, 
	                   time:2,
                       transition:"easeIn" + easingCombo.value, 
                       onUpdate:shapeDatas[i].draw,
                       onComplete:callback
                    });
	            }
        	}
        	else
        	{
                for(i = 0; i < shapeDatas.length; i++)
                {
                    shapeDatas[i].beginFill(0xffffff, 1);
                    shapeDatas[i].start_t = 0;
                    shapeDatas[i].end_t = 1;
                    shapeDatas[i].setThicknessType(thicknessType, thickness);
                    Tweener.addTween(shapeDatas[i], {
                        start_t:1, 
                        time:1.2, 
                        transition:"easeOut" + easingCombo.value, 
                        onUpdate:shapeDatas[i].draw,
                        onComplete:callback
                    });
                }
        	}

        }
	}
}
