﻿
/**
 *	ShapeのEdge:直線
 */

package {
	
	import flash.display.Graphics;
	import flash.geom.Point;
	
	public class EdgeLine
	{
		
		//パラメータ
		private var x0:Number;
		private var y0:Number;
		private var x1:Number;	//アンカー。使わんけど
		private var y1:Number;	//アンカー。使わんけど
		private var x2:Number;
		private var y2:Number;
		
		private var length_:Number;
		
		public var dx:Number;
		public var dy:Number;
		
		/**
		 *	コンストラクタ
		 */
		public function EdgeLine( _p0:Point , _p1:Point , _p2:Point ){
			setControls( _p0 , _p1 , _p2 );
		}
		
		/**
		 *	ポイントの更新
		 */
		public function setControls( _p0:Point , _p1:Point , _p2:Point ):void{
			x0 = _p0.x;
			y0 = _p0.y;
			x1 = _p1.x;
			y1 = _p1.y;
			x2 = _p2.x;
			y2 = _p2.y;
			
			var v:Point = new Point( x2-x0 , y2-y0 );
			length_ = v.length;
			
			v.normalize(1.0);
			dx = v.x;
			dy = v.y;
		}
		
		public function get p0x():Number{
			return x0;
		}
		public function get p0y():Number{
			return y0;
		}
		public function get p1x():Number{
			return x1;
		}
		public function get p1y():Number{
			return y1;
		}
		public function get p2x():Number{
			return x2;
		}
		public function get p2y():Number{
			return y2;
		}
		
		
		/**
		 *	線上の位置を取得
		 *	@param ｔ(0<=t<=1)
		 */
		public function getPosAt( t:Number ):Point{
			return new Point( x0 + dx*length_*t , y0 + dy*length_*t );
		}
		
		/**
		 *	線微分
		 *	@param ｔ(0<=t<=1)
		 */
		public function getDeffAt( t:Number ):Point{
			return new Point( dx , dy );
		}
		
		/**
		 *	線座標・ベクトル
		 *	@param ｔ(0<=t<=1)
		 */
		/*
		public function getVectorPointAt( t:Number ):VectorPoint{
			return new VectorPoint( x0 + dx*length_*t , y0 + dy*length_*t , new Point( dx , dy ) );
		}
		*/
		
		
		/**
		 *	線の長さ
		 */
		public function get length():Number{
			return length_;
		}
		
		
		/**
		 *	直線かどうか
		 */
		public function get isLine():Boolean{
			return true;
		}
		
		//------------------------------------------------------------
		
		
		public function toString():String{
			return "[line edge  x0=" +x0+ " y0=" +y0+ " x1=" +x1+ " y1=" +y1+ " x2=" +x2+ " y2=" +y2+ " ]";
		}
	}
	
}