﻿
/**
 *	Shapeのデータ
 */

/**

XML
<shape>
<edge x0="" y0="" x1="" y1="" x2="" y2="" line="0|1" />
</shape>


*/
package {
	
	import flash.display.Graphics;
	import flash.geom.Point;
	
	public class ShapeData{
		
		
		public var edges:Array;
		
		public var rates:Array;
		
		private var length_:Number = Number.NaN;
		
		
		/**
		 *	コンストラクタ
		 */
		public function ShapeData( dat:XML ){
			makeData( dat );
			length_ = getLength();
		}
		
		
		/**
		 *	XMLからデータ初期化
		 */
		private function makeData( dat:XML ):void{
			edges = new Array();
			var p0:Point;
			var p1:Point;
			var p2:Point;
			for each (var edge:XML in dat.edge ){
				
				p0 = new Point( Number(edge.@x0) , Number(edge.@y0) );
				p1 = new Point( Number(edge.@x1) , Number(edge.@y1) );
				p2 = new Point( Number(edge.@x2) , Number(edge.@y2) );
				
				if( edge.@line=="0" ){
					edges.push( new Bezier2DEx(p0, p2, p1) );
				}else{
					edges.push( new EdgeLineEx(p0, p1, p2) );
				}
			}
		}
		
		public function get length():uint{
			return edges.length;
		}
		
		
		/**
		 *	線の長さ
		 */
		public function get total_length():Number{
			return isNaN( length_ ) ? getLength() : length_;
		}
		
		private function getLength():Number{
			
			var i:int= 0;
			length_ = 0;
			for( i=0 ; i<edges.length ; i++ ){
				length_ += edges[i].length;
			}
			
			rates = new Array();
			for( i=0 ; i<edges.length ; i++ ){
				rates.push( edges[i].length/length_ );
			}
			
			return length_;
		}
	}
	
}