package
{
	import flash.display.Graphics;
	import flash.display.Sprite;

	public class ShapeDataSet extends Sprite
	{
		public static var LENEAR:String = "lenear";
		public static var IN:String = "in";
		public static var OUT:String = "out";
		public static var RIBBON:String = "ribbon";
		public static var UFO:String = "ufo";
		
		private var segment:uint = 300;
		private var segmentsData:Array;
		private var shapeData:ShapeData;
		public var start_t:Number;
		public var end_t:Number;
	    public var total:uint;
	    public var thickness:Number;
	    public var baseThickness:Number = 8;
        private var gColor:uint = 0; //graphics用
        private var gAlpha:Number = 1; //graphics用
		
		public function ShapeDataSet(dat:XML)
		{
			super();
	        shapeData = new ShapeData(dat);
	        total = shapeData.edges.length;
	        thickness = baseThickness;
	        start_t = 0;
	        end_t = 1;
	        setSegmentsData();
		}
		
		public function draw():void
		{
			var defaultObj:Object = {edge:0, t:0};
			var g:Graphics = this.graphics;
			var startSeg:int = calcToSegment(start_t) - 1;
            var endSeg:uint = calcToSegment(end_t);
            var startObj:Object = startSeg < 0 ? defaultObj : getSegmentsObj(startSeg);
            var endObj:Object = getSegmentsObj(endSeg);
            var currentObj:Object;
            var currentEdgeIdx:uint = startObj.edge;
            var endEdgeIdx:uint = endObj.edge;
            var edge:IEdge;
            
            thickness = baseThickness;
            g.clear();
            g.beginFill(gColor,gAlpha);
            
            //同じedge上
            if(currentEdgeIdx == endEdgeIdx)
            {
            	edge = shapeData.edges[currentEdgeIdx] as IEdge;
            	edge.set_t(startObj.t, endObj.t);
            	edge.draw(g);
            }
            else
            {
            	edge = shapeData.edges[currentEdgeIdx] as IEdge;
            	edge.set_t(startObj.t, 1);
            	edge.draw(g);
            	currentEdgeIdx++;
            	while(currentEdgeIdx < endEdgeIdx)
            	{
            		edge = shapeData.edges[currentEdgeIdx] as IEdge;
            		edge.set_t(0, 1);
            		edge.draw(g);
            		currentEdgeIdx++;
            	}
            	edge = shapeData.edges[endObj.edge] as IEdge;
            	edge.set_t(0, endObj.t);
            	edge.draw(g);
            }
            g.endFill();
		}
		
		private function getSegmentsObj(targetSeg:uint):Object
		{
			return segmentsData[targetSeg];
		}
		
		//どのedgeのどのtかを配列でもとめる
		private function setSegmentsData():void
		{
			segmentsData = new Array();
			var oneLen:Number = shapeData.total_length / segment;
			var temp:Array = new Array();
			var totalEdge:uint = shapeData.length;
			var i:uint;
			
			for(i = 0; i < totalEdge; i++)
			{
				temp.push(shapeData.edges[i].length);
			}
			var obj:Object;
			var edge:IEdge;
			var currentEdge:uint = 0;
            var sumLen:Number = 0;
            var targetLen:Number = oneLen;
            var currentMax:Number = temp[0];
            var _t:Number;
			for(i = 0; i < segment; i++)
			{
				while(targetLen > currentMax)
				{
					if(currentEdge == totalEdge - 1){ break; }
					sumLen += shapeData.edges[currentEdge].length;
					currentEdge++;
					currentMax = sumLen + shapeData.edges[currentEdge].length;
				}
				edge = shapeData.edges[currentEdge];
				_t = edge.getT_byLength(targetLen - sumLen);
				_t = ( isNaN(_t) || _t >= 1) ? 1 : _t;
                obj = 
                {
                    edge:currentEdge, 
                    t:_t
                }
                segmentsData.push(obj);
                targetLen += oneLen;
                if(currentEdge == totalEdge && targetLen > currentMax){ break; }
			}
			
			/*
			for(i = 0; i < segment; i++)
			{
				trace(i, segmentsData[i].edge, segmentsData[i].t);
			}
			*/
		}
		
        public function beginFill(color:uint = 0, alpha:Number = 1):void
        {
            this.gColor = color;
            this.gAlpha = alpha;
        }
        
        private function calcToSegment(target_t:Number):uint
        {
            var seg:uint = (segment -1) * target_t;
            return seg;
        }
        
        public function setThicknessType(type:String, maxThickness:Number):void
        {
        	var currentThickness:Number;
        	var nextThickness:Number;
        	var edge:IEdge;
        	var total:uint = shapeData.edges.length;   	
        	var d_angle:Number = Math.PI / total;
        	var angle:Number = d_angle;
        	for(var i:uint = 0; i < total; i++)
        	{
        	   edge = shapeData.edges[i] as IEdge;
	            switch(type)
	            {
	            	case LENEAR:
	            	   if(i == 0){ currentThickness = maxThickness; }
	            	   nextThickness = currentThickness;
	            	break;
	                case IN:
	                   if(i == 0){ currentThickness = maxThickness; }
	                   nextThickness = (total - i - 1) * maxThickness / total;
	                break;
	                case OUT:
                       if(i == 0){ currentThickness = 0; }
                       nextThickness = (i + 1) * maxThickness / total;
	                break;
	                case RIBBON:
	                   if(i == 0){ currentThickness = maxThickness; }
	                   nextThickness = maxThickness * Math.cos(angle);
	                   angle += d_angle;
	                break;
	                case UFO:
                       if(i == 0){ currentThickness = 0; }
                       nextThickness = maxThickness * Math.sin(angle);
                       angle += d_angle;
	                break;
	                default: break;
	            }
	            edge.setThickness(currentThickness, nextThickness);
	            currentThickness = nextThickness;
        	}
        }
	}
}